﻿Imports System
Imports System.Web.UI
Imports Telerik.Web.UI
Imports System.Web.UI.WebControls
Imports System.Data
Imports System.Data.SqlClient
Imports System.Configuration

Partial Class LoadOnDemandServerSide1
    Inherits System.Web.UI.Page
		
		Private Const ItemsPerRequest As Integer = 10

		Protected Sub RadComboBox1_ItemsRequested(sender As Object, e As RadComboBoxItemsRequestedEventArgs)
		Dim data As DataTable = GetData(e.Text)

		Dim itemOffset As Integer = e.NumberOfItems
		Dim endOffset As Integer = Math.Min(itemOffset + ItemsPerRequest, data.Rows.Count)
		e.EndOfItems = endOffset = data.Rows.Count

		Dim i As Integer = itemOffset
		While i < endOffset
			RadComboBox1.Items.Add(New RadComboBoxItem(data.Rows(i)("CompanyName").ToString(), data.Rows(i)("CompanyName").ToString()))
			System.Math.Max(System.Threading.Interlocked.Increment(i),i - 1)
		End While

		e.Message = GetStatusMessage(endOffset, data.Rows.Count)
		End Sub

		Private Shared Function GetStatusMessage(offset As Integer, total As Integer) As String
			If total <= 0 Then
				Return "No matches"
			End If

			Return [String].Format("Items <b>1</b>-<b>{0}</b> out of <b>{1}</b>", offset, total)
		End Function

		Private Shared Function GetData(text As String) As DataTable
			Dim adapter As New SqlDataAdapter("SELECT * from Customers WHERE CompanyName LIKE @text + '%'", ConfigurationManager.ConnectionStrings("TelerikVSXConnectionString").ConnectionString)
			adapter.SelectCommand.Parameters.AddWithValue("@text", text)

			Dim data As New DataTable()
			adapter.Fill(data)

			Return data
		End Function

		Private Shared Sub DisplaySelection(comboBox As RadComboBox, label As Label)
			If comboBox.Text <> [String].Empty Then
				label.Text = "You selected text: <b>" + comboBox.Text + "</b> and value: <b>" + comboBox.SelectedValue + "</b>"
			Else
				label.Text = "RadComboBox is empty"
			End If
		End Sub
		Protected Sub Button1_Click(sender As Object, e As EventArgs)
			DisplaySelection(RadComboBox1, Label1)
		End Sub		
		
End Class
